; WinAPI function import (written by Tomasz Grysztar, square brackets [] added by Jin X)
; usage:
;   simport kernel32, GetFirmwareEnvironmentVariableA  ; function name string can be omitted (like here)
;   api GetFirmwareEnvironmentVariable  ; only for functions with 'A' or 'W' suffix
macro	simport	library_label*, [label*, string]
{
    match ,string \{ define library_label#.collection label,`label \}
    match any, string \{ define library_label#.collection label,string \}
}

; wrapper of import macros (written by Tomasz Grysztar)
macro	import	library_label*, list&
{
    common
        local all
        define all
        irpv a, library_label#.collection \{ all equ all , a \}
        match a, list \{ all equ , list all \}
        match complete, all \{ import library_label complete \}
}

; DLL library import (written by Tomasz Grysztar)
; usage:
;   slibrary msvcrt  ; dll name string can be omitted (like here)
;   simport msvcrt, printf  ; function name string can be omitted (like here)
;  or:
;   simport msvcrt, printf,, getch, '_getch', scanf
macro	slibrary	library_label*, string
{
    match ,string \{ define import_library library_label,`library_label#'.DLL' \}
    match any, string \{ define import_library library_label,string \}
}

; wrapper of library macros (written by Tomasz Grysztar)
macro	library	list&
{
    common
        local all
        define all
        irpv a, import_library \{ all equ all , a \}
        match complete, list all \{ library complete \}
        irpv a, import_library \{ match library_label=,string, a \\{ import library_label \\} \}
}
